
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                    S y m b O S   -   C o n s t a n t s                     @
;@                                                                            @
;@             (c) 2000-2008 by Prodatron / SymbiosiS (Jörn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


;P R O C E S S - I D S
.PRC_ID_KERNEL   equ 1   ;kernel process
.PRC_ID_DESKTOP  equ 2   ;desktop manager process
.PRC_ID_SYSTEM   equ 3   ;system manager process


;M E S S A G E S
;General
.MSC_GEN_QUIT    equ 0   ;application is beeing asked, to quit itself
.MSC_GEN_FOCUS   equ 255 ;application is beeing asked, to focus its window

;Kernel Commands
.MSC_KRL_MTADDP  equ 1   ;add process (P1/2=stack, P3=priority (7 high - 1 low), P4=ram bank (0-8))
.MSC_KRL_MTDELP  equ 2   ;delete process (P1=ID)
.MSC_KRL_MTADDT  equ 3   ;add timer (P1/2=stack, P4=ram bank (0-8))
.MSC_KRL_MTDELT  equ 4   ;delete timer (P1=ID)
.MSC_KRL_MTSLPP  equ 5   ;set process to sleep mode
.MSC_KRL_MTWAKP  equ 6   ;wake up process
.MSC_KRL_TMADDT  equ 7   ;add counter service (P1/2=address, P3=ram bank, P4=process, P5=frequency)
.MSC_KRL_TMDELT  equ 8   ;delete counter service (P1/2=address, P3=ram bank)
.MSC_KRL_TMDELP  equ 9   ;delete all counter services of one process (P1=process ID)

;Kernel Responses
.MSR_KRL_MTADDP  equ 129 ;process has been added (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELP  equ 130 ;process has been deleted
.MSR_KRL_MTADDT  equ 131 ;timer process has been deleted (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELT  equ 132 ;timer has been removed
.MSR_KRL_MTSLPP  equ 133 ;process is sleeping now
.MSR_KRL_MTWAKP  equ 134 ;process has been waked up
.MSR_KRL_TMADDT  equ 135 ;counter service has been added (P1=0/1->ok/failed)
.MSR_KRL_TMDELT  equ 136 ;counter service has been deleted
.MSR_KRL_TMDELP  equ 137 ;all counter services of a process have been deleted

;System Commands
.MSC_SYS_PRGRUN  equ 16  ;load application or document (P1/2=address filename, P3=ram bank filename)
.MSC_SYS_PRGEND  equ 17  ;quit application (P1=ID)
.MSC_SYS_SYSWNX  equ 18  ;open dialogue to change current window (next) (-)
.MSC_SYS_SYSWPR  equ 19  ;open dialogue to change current window (previouse) (vorheriges) (-)
.MSC_SYS_PRGSTA  equ 20  ;open dialogue to load application or document (-)
.MSC_SYS_SYSSEC  equ 21  ;open system secuity dialogue (-)
.MSC_SYS_SYSQIT  equ 22  ;open shut shown dialogue (-)
.MSC_SYS_SYSOFF  equ 23  ;shut down (-)
.MSC_SYS_PRGSET  equ 24  ;start control panel (P1=submodul -> 0=main window, 1=display settings, 2=date/time)
.MSC_SYS_PRGTSK  equ 25  ;start taskmanager (-)
.MSC_SYS_SYSFIL  equ 26  ;call filemanager function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSC_SYS_SYSHLP  equ 27  ;start help (-)
.MSC_SYS_SYSCFG  equ 28  ;call config function (P1=number, 0=load, 1=save, 2=reload background)
.MSC_SYS_SYSWRN  equ 29  ;open message/confirm window (P1/2=adresse, P3=ram bank, P4=number of buttons)
.MSC_SYS_PRGSRV  equ 30  ;shared service function (P4=type [0=search, 1=start, 2=release], P1/2=addresse 12char ID, P3=ram bank 12char ID or P3=program ID, if type=2)
.MSC_SYS_SELOPN  equ 31  ;open fileselect dialogue (P6=filename ram bank, P8/9=filename address, P7=forbidden attributes, P10=max entries, P12=max buffer size)

;System Responses
.MSR_SYS_PRGRUN  equ 144 ;application has been started (P1=result -> 0=ok, 1=file doesnt exist, 2=file is not executable, 3=error while loading  [P8=filemanager error code], 4=memory full, P8=app ID, P9=process ID)
.MSR_SYS_SYSFIL  equ 154 ;filemanager function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSR_SYS_SYSWRN  equ 157 ;message/confirm window response (P1 -> 0=already in use, 1=opened [P2=number], 2=ok, 3=yes, 4=no, 5=cancel/close)
.MSR_SYS_PRGSRV  equ 158 ;shared service function response (P1=state [5=not found, other codes see MSR_SYS_PRGRUN], P8=app ID, P9=process ID)
.MSR_SYS_SELOPN  equ 159 ;message from fileselect dialogue (P1 -> 0=Ok, 1=cancel, 2=already in use, 3=no memory free, 4=no window free, -1=open ok, modal window has been opened [P2=number])

;Desktop Commands
.MSC_DSK_WINOPN  equ 32  ;open window (P1=ram bank, P2/3=address data record)
.MSC_DSK_WINMEN  equ 33  ;redraw menu bar (P1=window ID) [only if focus]
.MSC_DSK_WININH  equ 34  ;redraw window content (P1=window ID, P2=-1/-Num/Object, P3=Object) [only if focus]
.MSC_DSK_WINTOL  equ 35  ;redraw window toolbar (P1=window ID) [only if focus]
.MSC_DSK_WINTIT  equ 36  ;redraw window title (P1=window ID) [only if focus]
.MSC_DSK_WINSTA  equ 37  ;redraw window status lien (P1=window ID) [only if focus]
.MSC_DSK_WINMVX  equ 38  ;set content x offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINMVY  equ 39  ;set content y offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINTOP  equ 40  ;takes window to the front (P1=window ID) [always]
.MSC_DSK_WINMAX  equ 41  ;maximize window (P1=window ID) [always]
.MSC_DSK_WINMIN  equ 42  ;minimize window (P1=window ID) [always]
.MSC_DSK_WINMID  equ 43  ;restore window size (P1=window ID) [always]
.MSC_DSK_WINMOV  equ 44  ;moves window to a new position (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINSIZ  equ 45  ;resize the window (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINCLS  equ 46  ;closes and removes window (P1=window ID) [always]
.MSC_DSK_WINDIN  equ 47  ;redraw window content, even if it hasnt focus (P1=window ID, P2=-1/-Num/Objekt, P3=Object) [always]
.MSC_DSK_DSKSRV  equ 48  ;desktop service request (P1=type, P2-P5=parameters)
.MSC_DSK_WINSLD  equ 49  ;redraw window scrollbars (P1=window ID) [only if focus]
.MSC_DSK_WINPIN  equ 50  ;redraw window content part (P1=window ID, P2=-1/-Num/Object, P3=Object, P4/5=Xbeg, P6/7=Ybeg, P8/9=Xlen, P10/11=Ylen) [always]
.MSC_DSK_WINSIN  equ 51  ;redraw content of a super control (P1=window ID, P2=super control ID, P3=SubObject) [always]
.MSC_DSK_MENCTX  equ 52  ;opens context menu (P1=ram bank, P2/3=address data record, P4/5=Xbeg [-1=mouse position], P6/7=Ybeg) ##!!## doc+lib
.MSC_DSK_STIADD  equ 53  ;adds systray-icon (P1=ram bank, P2/3=address, P4=ID)
.MSC_DSK_STIREM  equ 54  ;removes systray-icon (P1=number)
.MSC_DSK_STIUPD  equ 55  ;updates systray-icon (P1=number)

;Desktop Responses
.MSR_DSK_WOPNER  equ 160 ;open window failed; the maximum of 32 windows has been reached
.MSR_DSK_WOPNOK  equ 161 ;open window successfull (P4=number)
.MSR_DSK_WCLICK  equ 162 ;window has been clicked (P1=window number, P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSR_DSK_DSKSRV  equ 163 ;desktop service answer (P1=type, P2-P5=parameters)
.MSR_DSK_WFOCUS  equ 164 ;window got/lost focus (P1=window number, P2=type [0=blur, 1=focus])
.MSR_DSK_CFOCUS  equ 165 ;control focus changed (P1=window number, P2=control number, P3=reason [0=mouse click/wheel, 1=tab key])
.MSR_DSK_WRESIZ  equ 166 ;window has been resized (P1=window number)
.MSR_DSK_WSCROL  equ 167 ;window content has been scrolled (P1=window number)
.MSR_DSK_MENCTX  equ 168 ;menu has been clicked or canceld (P1=1 ok, P2/3=value, P4=type [0=normal, 1=check]) ##!!## doc+lib
.MSR_DSK_STIADD  equ 169 ;result of adding systray-icon (P1=1 ok, P2=number)
.MSR_DSK_STICLK  equ 170 ;systray-icon has been clicked (P1=ID)

.MSR_DSK_EXTDSK  equ 191 ;command for extended desktop (used internally; P1=command, P2-x=parameters)

.FNC_DXT_DSKBGR  equ 001 ;background has been updated
.FNC_DXT_FILRUN  equ 002 ;file has been opened via prgrun (P2/3=address, P4=bank)
.FNC_DXT_FILBRW  equ 003 ;file has been selected via file browser (P2/3=address, P4=bank)
.FNC_DXT_MENCLK  equ 004 ;startmenu has been clicked (P2/3=value)
.FNC_DXT_DSKCLK  equ 005 ;desktop window has been clicked (P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)

;Shell Commands
.MSC_SHL_CHRINP  equ 64  ;char is requested (P1=channel [0=standard, 1=keyboard])
.MSC_SHL_STRINP  equ 65  ;line is requested (P1=channel [0=standard, 1=keyboard], P2=ram bank, P3/4=address)
.MSC_SHL_CHROUT  equ 66  ;char should be writtten (P1=channel [0=standard, 1=screen], P2=char)
.MSC_SHL_STROUT  equ 67  ;line should be writtten (P1=channel [0=standard, 1=screen], P2=ram bank, P3/4=address, P5=length)
.MSC_SHL_EXIT    equ 68  ;application released focus or quit itself (P1 -> 0=quit, 1=blur)
.MSC_SHL_PTHADD  equ 69  ;add additional path to current one (P1=base path, P3=addition path, P5=final path, P7=ram bank)

;Shell Responses
.MSR_SHL_CHRINP  equ 192 ;char has been received (P1=EOF-flag [0=no EOF], P2=char, P3=error status)
.MSR_SHL_STRINP  equ 193 ;line has been received (P1=EOF-flag [0=no EOF], P3=error status)
.MSR_SHL_CHROUT  equ 194 ;char has been written (P3=error status)
.MSR_SHL_STROUT  equ 195 ;line has been written (P3=error status)
.MSR_SHL_PTHADD  equ 197 ;path has been combined (P1=total end address, P3=directory end address, P5=flags)

;Screensaver Messages
.MSC_SAV_INIT    equ 1   ;initialises the screen saver (P1=bank of config data, P2/3=address of config data [64bytes])
.MSC_SAV_START   equ 2   ;start screen saver
.MSC_SAV_CONFIG  equ 3   ;open screen savers own config window (at the end the screen saver has to send the result back to the sender)
.MSR_SAV_CONFIG  equ 4   ;returns user adjusted screen saver config data (P1=bank of config data, P2/3=address of config data [64bytes])


;D E S K T O P - A C T I O N S
.DSK_ACT_CLOSE   equ 5   ;close button has been clicked or ALT+F4 has been pressed
.DSK_ACT_MENU    equ 6   ;menu entry has been clicked (P8/9=menu entry value)
.DSK_ACT_CONTENT equ 14  ;a control of the content has been clicked (P3=sub spec [see dsk_sub...], P4=key or P4/5=Xpos within the window, P6/7=Ypos, P8/9=control value)
.DSK_ACT_TOOLBAR equ 15  ;a control of the toolbar has been clicked (see DSK_ACT_CONTENT)
.DSK_ACT_KEY     equ 16  ;key has been pressed without touching/modifying a control (P4=Ascii Code)

.DSK_SUB_MLCLICK equ 0   ;left mouse button has been clicked
.DSK_SUB_MRCLICK equ 1   ;right mouse button has been clicked
.DSK_SUB_MDCLICK equ 2   ;double click with the left mouse button
.DSK_SUB_MMCLICK equ 3   ;middle mouse button has been clicked
.DSK_SUB_KEY     equ 7   ;keyboard has been clicked and did modify/click a control (P4=Ascii Code)
.DSK_SUB_MWHEEL  equ 8   ;mouse wheel has been moved (P4=Offset)


;D E S K T O P - S E R V I C E S
.DSK_SRV_MODGET  equ 1   ;get screen mode (output P2=mode, P3=virtual desktop)
.DSK_SRV_MODSET  equ 2   ;set screen mode (input P2=mode, P3=virtual desktop)
.DSK_SRV_COLGET  equ 3   ;get colour      (input P2=number, output P2=number, P3/4=RGB value)
.DSK_SRV_COLSET  equ 4   ;set colour      (input P2=number, P3/4=RGB value)
.DSK_SRV_DSKSTP  equ 5   ;freeze desktop  (input P2=type [0=Pen0, 1=Raster, 2=background, 255=no screen modification, switch off mouse])
.DSK_SRV_DSKCNT  equ 6   ;continue desktop
.DSK_SRV_DSKPNT  equ 7   ;clear desktop   (Eingabe P2=Typ [0=Pen0, 1=Raster, 2=background])
.DSK_SRV_DSKBGR  equ 8   ;initialize and redraw desktop background
.DSK_SRV_DSKPLT  equ 9   ;redraw the complete desktop
.DSK_SRV_DSKOPN  equ 11  ;open desktop background window


;C L I P B O A R D - T Y P E S
.CLPTYP_TEXT     equ 1   ;plain text
.CLPTYP_GRAPHIC  equ 2   ;graphic with extended header
.CLPTYP_ITEMS    equ 3   ;item list (*not defined yet*)
.CLPTYP_ICON     equ 4   ;desktop icon shortcut


;J U M P S
.jmp_memsum  equ #8100 ;MEMSUM
.jmp_sysinf  equ #8103 ;SYSINF
.jmp_clcnum  equ #8106 ;CLCNUM
.jmp_mtgcnt  equ #8109 ;MTGCNT
.jmp_timget  equ #810C ;TIMGET
.jmp_timset  equ #810F ;TIMSET
.jmp_memget  equ #8118 ;MEMGET
.jmp_memfre  equ #811B ;MEMFRE
.jmp_memsiz  equ #811E ;MEMSIZ
.jmp_meminf  equ #8121 ;MEMINF
.jmp_bnkrwd  equ #8124 ;BNKRWD
.jmp_bnkwwd  equ #8127 ;BNKWWD
.jmp_bnkrbt  equ #812A ;BNKRBT
.jmp_bnkwbt  equ #812D ;BNKWBT
.jmp_bnkcop  equ #8130 ;BNKCOP
.jmp_bnkget  equ #8133 ;BNKGET
                      ;**empty**
.jmp_scrget  equ #8139 ;SCRGET
.jmp_mosget  equ #813C ;MOSGET
.jmp_moskey  equ #813F ;MOSKEY
.jmp_bnk16c  equ #8142 ;BNK16C
.jmp_keytst  equ #8145 ;KEYTST
.jmp_keysta  equ #8148 ;KEYSTA
.jmp_keyput  equ #814B ;KEYPUT
.jmp_bufput  equ #814E ;BUFPUT
.jmp_bufget  equ #8151 ;BUFGET
.jmp_bufsta  equ #8154 ;BUFSTA
.jmp_iominp  equ #8157 ;IOMINP (cpc only)
.jmp_iomout  equ #815a ;IOMOUT (cpc only)

.jmp_bnkcll  equ #ff03 ;BNKCLL
.jmp_bnkret  equ #ff00 ;BNKRET


;Filemanager Functions (call via MSC_SYS_SYSFIL)
.FNC_FIL_STOINI  equ 000 ;Storage Init (Removes all mass storage devices)
.FNC_FIL_STONEW  equ 001 ;Storage New (Adds a new mass storage device)
.FNC_FIL_STORLD  equ 002 ;Storage Reload (Reloads a mass storage device, if its "removeable media" status is activated)
.FNC_FIL_STODEL  equ 003 ;Storage Delete (Removes an existing mass storage device)
.FNC_FIL_STOINP  equ 004 ;Storage ReadSector (Reads a sector from a mass storage device (no memory banking))
.FNC_FIL_STOOUT  equ 005 ;Storage WriteSector (Write a sector to a mass storage device (no memory banking))
.FNC_FIL_STOACT  equ 006 ;Storage Activate (Loads the format and the file system type of a mass storage device)
.FNC_FIL_STOINF  equ 007 ;Storage Information (Returns information about a mass storage device)
.FNC_FIL_STOTRN  equ 008 ;Storage DataTransfer (Reads or writes a number of sectors (512 bytes) from/to the mass storage device)

.FNC_FIL_DEVDIR  equ 013 ;
.FNC_FIL_DEVINI  equ 014 ;
.FNC_FIL_DEVSET  equ 015 ;

.FNC_FIL_FILINI  equ 016 ;File Init (Initialises the whole file manager)
.FNC_FIL_FILNEW  equ 017 ;File New (Creates a new file and opens it for read/write access)
.FNC_FIL_FILOPN  equ 018 ;File Open (Opens an existing file for read/write access)
.FNC_FIL_FILCLO  equ 019 ;File Close (Closes an opened file)
.FNC_FIL_FILINP  equ 020 ;File Input (Reads a specified amount of bytes out of an opened file)
.FNC_FIL_FILOUT  equ 021 ;File Output (Writes a specified amount of bytes into an opened file)
.FNC_FIL_FILPOI  equ 022 ;File Pointer (Moves the file pointer to another position)
.FNC_FIL_FILF2T  equ 023 ;File Decode Timestamp (Decodes the file timestamp, which is used for the file system)
.FNC_FIL_FILT2F  equ 024 ;File Encode Timestamp (Encodes the file timestamp, which is used for the file system)
.FNC_FIL_FILLIN  equ 025 ;File LineInput (Reads one text line out of an opened file)

.FNC_FIL_DIRDEV  equ 032 ;Directory Device (Selects the current drive)
.FNC_FIL_DIRPTH  equ 033 ;Directory Path (Selects the current path for the current or a different drive)
.FNC_FIL_DIRPRS  equ 034 ;Directory Property Set (Changes a property of a file or a directory)
.FNC_FIL_DIRPRR  equ 035 ;Directory Property Get (Reads a property of a file or a directory)
.FNC_FIL_DIRREN  equ 036 ;Directory Rename (Renames a file or a directory)
.FNC_FIL_DIRNEW  equ 037 ;Directory New (Creates a new directory)
.FNC_FIL_DIRINP  equ 038 ;Directory Input (Reads the content of a directory)
.FNC_FIL_DIRDEL  equ 039 ;Directory Delete (Deletes one or more files)
.FNC_FIL_DIRRMD  equ 040 ;Directory Delete Directory (Deletes a sub directory)
.FNC_FIL_DIRMOV  equ 041 ;Directory Move (Moves a file or sub directory into another directory of the same drive)
.FNC_FIL_DIRINF  equ 042 ;Directory Drive Information (Returns information about one drive)

;Network Daemon Functions
.FNC_NET_CFGGET  equ 001 ;config information
.FNC_NET_CFGSET  equ 002 ;config setting

.FNC_NET_TCPOPN  equ 016 ;TCP open
.FNC_NET_TCPCLO  equ 017 ;TCP close
.FNC_NET_TCPSTA  equ 018 ;TCP status
.FNC_NET_TCPRCV  equ 019 ;TCP receive
.FNC_NET_TCPSND  equ 020 ;TCP send
.FNC_NET_TCPSKP  equ 021 ;TCP skip received data
.FNC_NET_TCPFLS  equ 022 ;TCP flush send buffer
.FNC_NET_TCPDIS  equ 023 ;TCP disconnect
.MSR_NET_TCPEVT  equ 159 ;TCP event

.FNC_NET_UDPOPN  equ 032 ;UDP open
.FNC_NET_UDPCLO  equ 033 ;UDP close
.FNC_NET_UDPSTA  equ 034 ;UDP status
.FNC_NET_UDPRCV  equ 035 ;UDP receive
.FNC_NET_UDPSND  equ 036 ;UDP send
.FNC_NET_UDPSKP  equ 037 ;UDP skip received data
.MSR_NET_UDPEVT  equ 175 ;UDP event

.FNC_NET_DNSRSV  equ 112 ;DNS resolve
.FNC_NET_DNSVFY  equ 113 ;DNS verify

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 62  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatVer     equ 88  ;Version 3
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;


.ScanCode_E	equ 45

;----------------------------------------------------------------------------;
; V9990 register and port defines                                            ;
;----------------------------------------------------------------------------;

; Port defines
.g9k_VRAM				equ	#60				; R/W
.g9k_PALETTE			equ	#61				; R/W
.g9k_CMD_DATA			equ	#62				; R/W
.g9k_REG_DATA			equ	#63				; R/W
.g9k_REG_SELECT			equ	#64				; W
.g9k_STATUS				equ	#65				; R
.g9k_INT_FLAG			equ	#66				; R/W
.g9k_SYS_CTRL			equ	#67				; W
.g9k_OUTPUT_CTRL		equ	#6F 		    ; R/W

; Bit defines g9k_SYS_CTRL
.g9k_SYS_CTRL_SRS		equ	2				; Power on reset state
.g9k_SYS_CTRL_MCKIN		equ	1				; Select MCKIN terminal
.g9k_SYS_CTRL_XTAL		equ	0				; Select XTAL

; Register defines
.g9k_WRITE_ADDR			equ	0				; W
.g9k_READ_ADDR			equ	3				; W
.g9k_SCREEN_MODE0		equ	6				; R/W
.g9k_SCREEN_MODE1		equ 7				; R/W
.g9k_CTRL				equ	8				; R/W
.g9k_INT_ENABLE         equ 9       		; R/W
.g9k_INT_V_LINE_LO		equ	10				; R/W	
.g9k_INT_V_LINE_HI		equ	11				; R/W
.g9k_INT_H_LINE			equ	12				; R/W	
.g9k_PALETTE_CTRL		equ	13				; W
.g9k_PALETTE_PTR		equ	14				; W
.g9k_BACK_DROP_COLOR 	equ 15		      	; R/W
.g9k_DISPLAY_ADJUST		equ	16				; R/W
.g9k_SCROLL_LOW_Y		equ 17 			    ; R/W
.g9k_SCROLL_HIGH_Y		equ 18      		; R/W
.g9k_SCROLL_LOW_X		equ 19      		; R/W
.g9k_SCROLL_HIGH_X		equ 20      		; R/W
.g9k_SCROLL_LOW_Y_B		equ 21 				; R/W
.g9k_SCROLL_HIGH_Y_B	equ 22      		; R/W
.g9k_SCROLL_LOW_X_B		equ 23      		; R/W
.g9k_SCROLL_HIGH_X_B	equ 24      		; R/W
.g9k_PAT_GEN_TABLE   	equ 25      		; R/W
.g9k_LCD_CTRL        	equ 26      		; R/W
.g9k_PRIORITY_CTRL  	equ 27      		; R/W
.g9k_SPR_PAL_CTRL		equ	28				; W
.g9k_SC_X				equ	32				; W
.g9k_SC_Y				equ	34				; W
.g9k_DS_X				equ	36				; W
.g9k_DS_Y				equ	38				; W
.g9k_NX					equ	40				; W
.g9k_NY					equ	42				; W
.g9k_ARG				equ	44				; W
.g9k_LOP				equ	45				; W
.g9k_WRITE_MASK			equ	46				; W
.g9k_FC					equ	48				; W
.g9k_BC					equ	50				; W
.g9k_OPCODE				equ	52				; W

; Register Select options
.g9k_DIS_INC_READ		equ	64
.g9k_DIS_INC_WRITE		equ	128

; Bit defines g9k_SCREEN_MODE0 (register 6)
.g9k_SCR0_STANDBY		equ	192				; Stand by mode
.g9k_SCR0_BITMAP		equ	128				; Select Bit map mode
.g9k_SCR0_P2			equ	64				; Select P1 mode
.g9k_SCR0_P1			equ	0				; Select P1 mode
.g9k_SCR0_DTCLK			equ	32				; Master Dot clock not divided
.g9k_SCR0_DTCLK2		equ	16				; Master Dot clock divided by 2
.g9k_SCR0_DTCLK4		equ	0				; Master Dot clock divided by 4
.g9k_SCR0_XIM2048		equ	12				; Image size = 2048
.g9k_SCR0_XIM1024		equ	8				; Image size = 1024
.g9k_SCR0_XIM512		equ	4				; Image size = 512
.g9k_SCR0_XIM256		equ	0				; Image size = 256
.g9k_SCR0_16BIT			equ	3				; 16 bits/dot
.g9k_SCR0_8BIT			equ	2				; 8 bits/dot
.g9k_SCR0_4BIT			equ	1				; 4 bits/dot
.g9k_SCR0_2BIT			equ 0				; 2 bits/dot

; Bit defines g9k_SCREEN_MODE1 (register 7)
.g9k_SCR1_C25M			equ	64				; Select 640*480 mode
.g9k_SCR1_SM1			equ	32				; Selection of 263 lines during non interlace , else 262
.g9k_SCR1_SM			equ	16				; Selection of horizontal frequency 1H=fsc/227.5
.g9k_SCR1_PAL			equ	8				; Select PAL, else NTSC
.g9k_SCR1_EO			equ	4				; Select of vertical resoltion of twice the non-interlace resolution
.g9k_SCR1_IL			equ	2				; Select Interlace
.g9k_SCR1_HSCN			equ	1				; Select High scan mode

; Bit defines g9k_CTRL    (Register 8)
.g9k_CTRL_DISP			equ	128				; Display VRAM
.g9k_CTRL_DIS_SPD		equ	64				; Disable display sprite (cursor)
.g9k_CTRL_YSE			equ	32				; /YS Enable
.g9k_CTRL_VWTE			equ	16				; VRAM Serial data bus control during digitization
.g9k_CTRL_VWM			equ	8				; VRAM write control during digitization
.g9k_CTRL_DMAE			equ	4				; Enable DMAQ output
.g9k_CTRL_VRAM512		equ	2				; VRAM=512KB
.g9k_CTRL_VRAM256		equ	1				; VRAM=256KB
.g9k_CTRL_VRAM128		equ	0				; VRAM=128KB

; Bit defines g9k_INT_ENABLE (register 9)
.g9k_INT_IECE	        equ 4       		; Command end interrupt enable control
.g9k_INT_IEH	        equ 2       		; Display position interrupt enable
.g9k_INT_IEV	        equ 1       		; Int. enable during vertical retrace line interval

; Bit Defines g9k_PALETTE_CTRL  (Register 13)
.g9k_PAL_CTRL_YUV		equ	192				; YUV mode
.g9k_PAL_CTRL_YJK		equ	128				; YJK mode
.g9k_PAL_CTRL_256		equ	64				; 256 color mode
.g9k_PAL_CTRL_PAL		equ	0				; Pallete mode
.g9k_PAL_CTRL_YAE		equ	32				; Enable YUV/YJK RGB mixing mode

; Bit defines g9k_LOP           (Register 45)
.g9k_LOP_TP				equ	16
.g9k_LOP_WCSC			equ	12
.g9k_LOP_WCNOTSC		equ	3
.g9k_LOP_WCANDSC		equ	8
.g9k_LOP_WCORSC			equ	14
.g9k_LOP_WCEORSC		equ	6

; Bit defines g9k_ARG
.g9k_ARG_MAJ			equ	1
.g9k_ARG_NEG			equ	2
.g9k_ARG_DIX			equ	4
.g9k_ARG_DIY			equ	8

; Blitter Commands g9k_OPCODE    (Register 52)
.g9k_OPCODE_STOP		equ	#00				; Command being excuted is stopped 
.g9k_OPCODE_LMMC		equ	#10     		; Data is transferred from CPU to VRAM rectangle area
.g9k_OPCODE_LMMV		equ	#20     		; VRAM rectangle area is painted out
.g9k_OPCODE_LMCM		equ	#30				; VRAM rectangle area is transferred to CPU
.g9k_OPCODE_LMMM		equ	#40				; Rectangle area os transferred from VRAM to VRAM
.g9k_OPCODE_CMMC		equ	#050			; CPU character data is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMK		equ	#060			; Kanji ROM data is is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMM		equ	#070			; VRAM character data is color-developed and transferred to VRAM rectangle area 
.g9k_OPCODE_BMXL		equ	#080			; Data on VRAM linear address is transferred to VRAM rectangle area
.g9k_OPCODE_BMLX		equ	#090			; VRAM rectangle area is transferred to VRAM linear address 
.g9k_OPCODE_BMLL		equ	#0A0			; Data on VRAM linear address is transferred to VRAM linear address 
.g9k_OPCODE_LINE		equ	#0B0			; Straight line is drawer on X-Y co-ordinates
.g9k_OPCODE_SRCH		equ	#0C0			; Border color co-ordinates on X-Y are detected
.g9k_OPCODE_POINT		equ	#0D0			; Color code on specified point on X-Y is read out
.g9k_OPCODE_PSET		equ	#0E0			; Drawing is executed at drawing point on X-Y co-ordinates
.g9k_OPCODE_ADVN		equ	#0F0			; Drawing point on X-Y co-ordinates is shifted

; Bit defines g9k_STATUS
.g9k_STATUS_TR          equ 128
.g9k_STATUS_VR          equ 64
.g9k_STATUS_HR          equ 32
.g9k_STATUS_BD          equ 16
.g9k_STATUS_MSC         equ 4
.g9k_STATUS_EO          equ 2
.g9k_STATUS_CE          equ 1

; Mode select defines for SetScreenMode
.g9k_MODE_P1			equ	0				; Pattern mode 0 256 212
.g9k_MODE_P2			equ	1				; Pattern mode 1 512 212
.g9k_MODE_B1			equ	2				; Bitmap mode 1 256 212
.g9k_MODE_B2			equ	3				; Bitmap mode 2 384 240
.g9k_MODE_B3			equ	4				; Bitmap mode 3 512 212
.g9k_MODE_B4			equ	5				; Bitmap mode 4 768 240
.g9k_MODE_B5			equ	6				; Bitmap mode 5 640 400 (VGA)
.g9k_MODE_B6			equ	7				; Bitmap mode 6 640 480 (VGA)
.g9k_MODE_B7			equ	8				; Bitmap mode 7 1024 212 (Undocumented v9990 mode)

; Fixed VRAM addresses
;g9k_SCRA_PAT_NAME_TABLE EQU     07C000h
;g9k_SCRB_PAT_NAME_TABLE EQU     07E000h
;g9k_P1_SPR_ATTRIB_TABLE EQU     03FE00h
;g9k_P2_SPR_ATTRIB_TABLE EQU     07BE00h

;g9k_CURSOR0_ATTRIB      EQU     07FE00h
;g9k_CURSOR1_ATTRIB      EQU     07FE08h

;g9k_CURSOR0_PAT_DATA    EQU     07FF00h
;g9k_CURSOR1_PAT_DATA    EQU     07FF80h

.g9k_RED                 equ 32
.g9k_GREEN               equ 1024
.g9k_BLUE                equ 1


;g9k_WRITE_MASK_LAYER_A	EQU	000FFh
;g9k_WRITE_MASK_LAYER_B	EQU	0FF00h
SYMBOS_ORG #100
;**** 256 Application Header ****
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
.AppDataSize   dw  AppTrnBeg-AppDatBeg      ;Length of Dat
.AppTrnSize    dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
               dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "SymbOS Application      ",0
.AppIcon16     db  1
.AppIconOff    dw  Icon24_Data-AppCodBeg
.Appxxxx       db  0,0,0,0,0
.AppMemTab     db  "SymExe10"             ;File Check
.AppDataLen    equ  AppTrnBeg-AppDatBeg      ;Length of Data
.AppTrnLen     equ  AppTrnEnd-AppTrnBeg      ;Length of Transfer
.AppTrnLen2    equ  2000-AppTrnLen
.AppDataLen2    equ  2000-AppDataLen
.AppExtCode    dw  0
.AppExtData    dw  AppDataLen2
.AppExtTrans   dw  AppTrnLen2
               ds  28
.AppIcnSml    
.AppStartForm  equ 0
        db 2,8,8
      db     15,15,14,3,13,13,73,73,73,73,75,75,60,135,15,15
.AppIcnBig    
.AppIcnLrg       db 6,24,24
             db 255,255,255,255,255,255
             db 136,0,0,0,0,17
             db 136,0,16,224,0,17
             db 136,16,225,30,128,17
             db 136,33,11,15,104,17
             db 136,67,15,15,30,17
             db 136,135,30,135,30,17
             db 136,135,44,67,30,17
             db 152,15,72,33,30,17
             db 152,15,72,33,30,17
             db 152,15,72,33,30,17
             db 152,15,72,67,44,17
             db 152,15,60,135,44,17
             db 152,15,15,15,72,17
             db 136,135,15,15,192,17
             db 136,67,15,30,0,17
             db 136,48,195,15,128,17
             db 136,0,33,15,120,145
             db 136,0,16,15,15,145
             db 136,0,0,135,15,145
             db 136,0,0,67,15,145
             db 136,0,0,48,240,145
             db 136,0,0,0,0,17
             db 255,255,255,255,255,255

;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_In_Use			db 	0

.AppPrz:
;**** Open Primary Window ****

		ld		hl,AppTrnEnd+260
		ld		a,h
		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer

		ld		a,AppStartForm					;**** Form to Open first
		ld		l,a
		call	Quig_Form_Open					;**** Form Opener
;****************************************
;**** Main Application Control Loop *****
;****************************************
.Quig_Control_Loop:
		ld		a,(V_App_In_Use)
		And		a
		jr		nz,Quig_Control_Loop_1
		rst		#30								;Wait for message
		ld		a,(AppPrzN)		
       	db		#dd:ld l,a
		db		#dd:ld h,-1
 		ld		iy,AppMsgB
		rst		#18
		db		#dd:dec l						;AppMsgB should be populated
		jr		nz,Quig_Control_Loop_2			;No Message so just run Main()code.	
		ld		a,(AppMsgB+0)					
		or		a
		jp		z,Quig_End
		scf
		cp		MSR_DSK_WCLICK					;**** Click on a Control
		jp		z,Quig_Control_Event
		cp		MSR_DSK_WRESIZ					;**** Resize window ?
		jp		z,Quig_Form_Event_Resize
		cp		MSR_DSK_WSCROL					;**** Scrolled Form ?
		jp		z,Quig_Form_Event_Scroll		
		cp		MSR_DSK_CFOCUS					;**** Focus change ?
		jp		z,Quig_Form_Event_Focus		
.Quig_Control_Loop_2:
		call	qfunc_main
.Quig_Control_Loop_1:
		Xor		a
		ld		(V_App_In_Use),a
.Quig_Control_Loop_Change:		
		jp		Quig_Control_Loop
		

		
		
;**** Redirect a Clicked on Control Event		
.Quig_Control_Event:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		a,(Event_Type)	 		
 		cp		DSK_ACT_CONTENT
 		jp		z,Quig_Content
 		cp		DSK_ACT_TOOLBAR
 		jp		z,Quig_Tool		
		cp		DSK_ACT_CLOSE
		jp		z,Quig_End
		cp		DSK_ACT_MENU
 		jp		z,Quig_Menu
		cp		DSK_ACT_KEY
		jp		z,Quig_Key		
		jp		Quig_Control_Loop_1
		
;**** Form Event ****
.Quig_Form_Event_Focus
		ld		a,5
		jr		Quig_Form_Event_X	
.Quig_Form_Event_Scroll
		ld		a,4
		jr		Quig_Form_Event_X	
.Quig_Form_Event_Resize
		ld		a,3
.Quig_Form_Event_X:		
		ld		(Quig_Form_Event_X_1+1),a
		call	Quig_FormSearch
		ld		a,e
.Quig_Form_Event_X_1
		ld		c,0								;**** C = 3/4 etc
		call	SyB_Call_Form_Event
		jp		Quig_Control_Loop_1
		
;*********************
;**** Key Control ****
;*********************
.Quig_Key:
		ld		a,(AppMsgB+4)
		and		%10000000
		jp		z,Quig_Content
		jp		Quig_Control_Loop_1

;**********************
;**** Menu Control ****
;**********************
.Quig_Menu:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		hl,(AppMsgB+8)
		Xor		a
		cp		h
		jr		nz,Quig_Call_Set12
		cp		l
		jp		z,Quig_Control_Loop_1
.Quig_Call_Set12
		Xor		a
		ld		(V_App_In_Use),a
		push	ix
		push	iy
		ld		(Quig_Call_Set2+1),hl
.Quig_Call_Set2:
		call	0
		pop		iy
		pop		ix		
		jp		Quig_Control_Loop_1

		
;****************************************
;**** User has clicked on one Tool Control ****
;****************************************		
.Quig_Tool:
		ld		hl,ControWindowDataList+2
		Jr		Quig_Content2
;**** User has clicked on one Control ****
.Quig_Content:
		ld		hl,ControWindowDataList
.Quig_Content2:
		push	hl
		call	Quig_FormSearch
		ld		l,e
		ld		h,0
		add		hl,hl
		add		hl,hl	
		pop		de
		add		hl,de
	
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		a,(Event_Control_ID)
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,de
		inc		hl
		inc		hl
		ld		a,(hl)
		cp		43				;CHeck for List Sort
		jp		nz,Quig_Content3
;Do list sort whatever		
		push	hl
		inc		hl
		inc		hl				;Not at ExtData
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a				;HL=Address of Extended List data
		
		ld		c,(hl)			;BC=Lines
		inc		hl
;		ld		b,(hl)
		inc		hl
		inc		hl
		inc		hl
		ld		e,(hl)			;DE=Location of Data
		inc		hl
		ld		d,(hl)
		inc		hl
		inc		hl
		inc		hl
		ld		b,(hl)			;Number of columns
		ex		de,hl
		;So HL=Addr data;BC Lines
.Quig_List_Stuff_Loop1		
		ld		a,c
		and		a
		jr		z,Quig_List_Stuff_Exit
		dec		c
		inc		hl
		inc		hl
		ld		a,b
.Quig_List_Stuff_Loop2		
		ld		e,(hl)
		inc		hl
		push	hl
		ld		d,(hl)
		dec		hl			;HL=Start of data again
		ex		de,hl
		
		dec		hl
		dec		hl
		dec		hl
		ld		(hl),d
		dec		hl
		ld		(hl),e
		
		pop		hl
		inc		hl
		dec		a
		jr		nz,Quig_List_Stuff_Loop2
		
		jr		Quig_List_Stuff_Loop1
		
.Quig_List_Stuff_Exit		
		pop		hl
.Quig_Content3:		
		ld		de,12
		add		hl,de
		ld		e,(hl)
		inc 	hl
		ld		d,(hl)
		Xor		a
		cp		e
		jp		nz,Quig_Content_Event_1
		cp		d
		jp		nz,Quig_Content_Event_1
		jp		Quig_Control_Loop
.Quig_Content_Event_1:
		Xor		a
		ld		(V_App_In_Use),a
		ld		(Quig_Content_Event_2+1),de
.Quig_Content_Event_2
		call	0		
		jp		Quig_Control_Loop_1	

;****                       ****		
;**** Shut down Application ****
;****                       ****		
.Quig_End:
		call	Quig_FormSearch
		ld		l,e
		call	Quig_Form_Close
		ld		a,(Quig_Form_No)
		and		a
		jp		z,Quig_End_X
		jp		Quig_Control_Loop_1
.Quig_End_X:		
		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.Quig_End_1
 		rst		#30
		jr		Quig_End_1
	
;****                  ****
;**** HL = Form Number
;****                  ****
.Quig_Form_Open:
		ld		a,l
		call 	Quig_Form_Return
		cp		255								;
		ret		nz								;**** If not clear then Return 
		push	hl
		ld		a,(Quig_Form_No)				;**** A = SymStudio Window Number			
		ld		c,0								;**** C = 0 = Get data Begin Address
		call	Quig_GetWindowEventAddr			;**** Get Address of Window Data
		ld		e,(hl)
		inc		hl
		ld		d,(hl)							;**** DE = Address of Window Data
		ld		a,(AppBnkNum)
		inclib 	SYDESKTOP.WINOPN
		call	SyDesktop_WINOPN
		pop		hl
		ret		c								;**** If Carry then hasn't Opened window
		ld		(hl),a							;**** Store Inetrnal number into form list
		ld		a,(Quig_Form_No)				;**** A = SymStudio Window Number
		ld		c,1								;**** C = 1 = Get Open Address
		call	SyB_Call_Form_Event
		Xor		a		
		ret
;****              ****		
;**** Close a Form ****
;****              ****
.Quig_Form_Close:	
		ld		a,l
		call	Quig_Form_Return
		cp		255
		ret		z
		push	hl
		ld 		c,MSC_DSK_WINCLS
        call 	SyDesktop_SendMessage
		pop		hl
		ld		a,255
		ld		(hl),a		
		ld		a,(Quig_Form_No)				;**** A = SymStudio Window Number
		ld		c,2								;**** C = 2 = Get Close Address
		call	SyB_Call_Form_Event
		ret

;**** Get a Internal Window number in a
;IN A = Window
;OUT A = Symbos Window number or #ff
;    HL =  address of Internal window stoe
.Quig_Form_Return
		ld		(Quig_Form_No),a				;**** Store the number of the Internal Window
		ld		hl,Quig_FormIDs					;**** Point to Start of Window List
		ld		e,a								;**** DE = A
		ld		d,0
		add		hl,de							;**** Calc Position
		ld		a,(hl)							;**** Checks if exists
		ret
;****                       ****
;**** Check If Event and Do ****
;****                       ****
;A=Form No C=Event To search
.SyB_Call_Form_Event:
		call	Quig_GetWindowEventAddr
		Xor		a
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		cp		e		
		jr		nz,SyB_Call_Form_Event_2	
		cp		d
		ret		z
.SyB_Call_Form_Event_2	
		ld		(SyB_Call_Form_Event_3+1),de
.SyB_Call_Form_Event_3
		call	0
		ret	
		
;****                                 ****
;**** Get User Form No fro OS Form No ****
;****                                 ****
.Quig_FormSearch:
		ld		a,(Event_Form_ID)
		ld		b,8
		ld		e,0
		ld		hl,Quig_FormIDs	
.Quig_FormSearch_1	
		cp		(hl)
		ret		z
		inc		e
		inc		hl
		djnz	Quig_FormSearch_1
		ret		

;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
.SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
.SyCallN db 0		
		
;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
;****     4 = Main Loop Address
.Quig_GetWindowEventAddr
		add		a				;Times 2
		add		a				;Times 4
		add		a				;Times 8
		add		c				;Event
		add		a				;Times 16 + (Event*2)
		ld		hl,App_Form_List
		ld		e,a
		ld		d,0
		add		hl,de
		ret

.Quig_Form_No:				db	0
.Quig_FormIDs:				db  255,255,255,255,255,255,255,255

.Quig_Directory_Error_Byte:		db	0
.Quig_String_Buffer_Area_Start 	equ AppTrnEnd+260
.Quig_String_Buffer_Top			equ AppTrnEnd+260+AppTrnLen2
.Quig_String_Buffer_StackNo:	dw 0
.Quig_String_Buffer_Pos:		dw AppTrnEnd+260
.Quig_String_Buffer_Stack:		dw AppTrnEnd+260,0,0,0,0,0,0,0,0,0
.Quig_String_AS_HByte:			db 0
.Quig_String_Pos:				dw Quig_String_End_Text+4

		
.ErrorNum:					dw	0
.ErrorPC:					dw	0
.False:						db	0
.True:						db	1
.tcounter					dw	0


	
	
QUIGLINE 1
// Quigs 1.01 Application for Symbos
QUIGLINE 2
// Name:
QUIGLINE 3
// Coder:
QUIGLINE 4
// Date / Version:
QUIGLINE 5

QUIGLINE 6
// Declare variables
QUIGLINE 7

QUIGLINE 8
Var myfile:File
QUIGLINE 9
// End declares
QUIGLINE 10

QUIGLINE 11
Function Main:Void()
QUIGLINE 12
	// Main loop
QUIGLINE 13
EndF
QUIGLINE 14

QUIGLINE 15
Function Button1.Event:Void()
QUIGLINE 16
	// Note that WinApe doesnt allow dsk writing to certain media.
QUIGLINE 17
	// I'm using a:\ for simplicity. If the File doesnt save it will be the emulator stopping the WRITE
QUIGLINE 18
	// On real media you could use App.Path which would be the root directory
QUIGLINE 19
	myfile.New "a:\data.dat"
QUIGLINE 20
	If myfile.Status Then
QUIGLINE 21
		myfile.WriteString TextBox1.Text.Get
QUIGLINE 22
		myfile.Close
QUIGLINE 23
		Label1.Text.RSet "File Saved!"
QUIGLINE 24
	EndIf
QUIGLINE 25
EndF
QUIGLINE 26
Function Button2.Event:Void()
QUIGLINE 27
	//
QUIGLINE 28
	myfile.Open "a:\data.dat"
QUIGLINE 29
	If myfile.Status Then
QUIGLINE 30
		TextBox2.Text.Set myfile.ReadString()
QUIGLINE 31
		TextBox2.Refresh
QUIGLINE 32
		Label1.Text.RSet "File loaded!"
QUIGLINE 33
	Else
QUIGLINE 34
		Label1.Text.RSet "No file"
QUIGLINE 35
	EndIf
QUIGLINE 36
	myfile.Close
QUIGLINE 37
EndF
QUIGLINE 38

QUIGLINE 39




    ASM
;**** Core End
.Quig_CodeEnd:db 0
;**********************
;**** Data Section ****
;**********************
.AppDatBeg
.AppFormStart:    dw Form1_Begin
.AppFormLists
    dw Form1_ControlWindowData
;**** Form Icon Data ***
;**** Define User Graphics ****
.Icon24_Data
.Icon24_Data_WidthByte:     db 12
.Icon24_Data_WidthPixel:    db 24
.Icon24_Data_Height:        db 24
.Icon24_Data_DataAddr:      dw Icon24_Data_Data
.Icon24_Data_EncodeAddr:    dw Icon24_Data_Encode
.Icon24_Data_Size:          dw 288
.Icon24_Data_Encode:        db 5
.Icon24_Data_Data:          
             db 51,51,51,51,51,51,51,51,51,51,51,51
             db 48,0,0,0,0,0,0,0,0,0,0,3
             db 48,0,0,0,0,1,17,16,0,0,0,3
             db 48,0,0,1,17,18,34,33,16,0,0,3
             db 48,0,0,18,32,34,34,34,33,16,0,3
             db 48,0,1,34,34,34,34,34,34,33,0,3
             db 48,0,18,34,34,33,18,34,34,33,0,3
             db 48,0,18,34,34,16,1,34,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,1,34,34,16,0,3
             db 48,1,34,34,34,17,18,34,34,16,0,3
             db 48,1,34,34,34,34,34,34,33,0,0,3
             db 48,0,18,34,34,34,34,34,17,0,0,3
             db 48,0,1,34,34,34,34,33,0,0,0,3
             db 48,0,0,17,17,34,34,34,16,0,0,3
             db 48,0,0,0,0,18,34,34,33,17,16,3
             db 48,0,0,0,0,1,34,34,34,34,16,3
             db 48,0,0,0,0,0,18,34,34,34,16,3
             db 48,0,0,0,0,0,1,34,34,34,16,3
             db 48,0,0,0,0,0,0,17,17,17,16,3
             db 48,0,0,0,0,0,0,0,0,0,0,3
             db 51,51,51,51,51,51,51,51,51,51,51,51
.Sheet_Data4:                   
.Sheet_Data4_WidthByte:     db 2
.Sheet_Data4_WidthPixel:    db 1
.Sheet_Data4_Height:        db 1
.Sheet_Data4_DataAddr:      dw Sheet_Data4_Data
.Sheet_Data4_EncodeAddr:    dw Sheet_Data4_Encode
.Sheet_Data4_Size:          dw 1
.Sheet_Data4_Encode:        db 0
.Sheet_Data4_Data:          dw 0
;**** Define User Variables ****
.File_Select_Text:   dw File_Select_Text_Data+4
.Directory_Select_Text:   dw Directory_Select_Text_Data+4
.var_byt_myfile_handle:   db 0
.var_byt_myfile_status:   db 0
.var_byt_myfile_eof:   db 0
;Spongebob
;**** String Data ****
.Quigs_String_Data_Start:
.File_Select_Text_Data:         dw File_Select_Text:dw 1:db 0
.Directory_Select_Text_Data:    dw Directory_Select_Text:dw 1:db 0
.Quig_Dialog_1_Data:            dw Quig_Dialog_1:dw 1:db 0
.Quig_Dialog_2_Data:            dw Quig_Dialog_2:dw 1:db 0
.Quig_Dialog_3_Data:            dw Quig_Dialog_3:dw 1:db 0
.Form1_Text_Data:               dw Form1_Text:dw 7:db "Form 1",0
.Form1_Status_Text_Data:        dw Form1_Status_Text:dw 1:db 0
.Button1_Text_Data:             dw Button1_Text:dw 10:db "Save File",0
.Button2_Text_Data:             dw Button2_Text:dw 10:db "Read File",0
.Label1_Text_Data:              dw Label1_Text:dw 17:db "Nothing done yet",0
.Quig_String_Count   Equ 10
.Quig_String_End_Text:   db  0,0,0,0,0


;**************************
;**** Transfer Section ****
;**************************
.AppTrnBeg
          ds    256
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB
.Event_Message       db 0         ;0 Message No 16
.Event_Form_ID       db 0         ;1 Event happned on which Form
.Event_Type          db 0         ;2 Type of Event
.Event_UserInput     db 0         ;3 Key or Mouse Event
.Event_Key_ASCII                  ; Key ASCII - Shared Byte with next
.Event_MouseX        dw 0         ;4 MouseX when event happens
.Event_MouseY        dw 0         ;6 MouseY when event happens
.Event_Control_ID    dw 0         ;8 Control ID No
.Event_8             db 0         ;10
.Event_9             db 0         ;11
.Event_10            db 0         ;12
.Event_11            db 0         ;13
.Quig_Machine_Type   db 0    ;0=464, 1=664, 2=6128, 3=464Plus, 4=6128Plus 6=Enterprise 64/128 7=MSX1 8=MSX2, 9=MSX2+, 10=MSX TurboR 12=PCW8xxx, 13=PCW9xxx
.Quig_Null_String    db 0
;**** Dialog Transfer ****
.Quig_Dialog_1:      dw Quig_Dialog_1_Data+4,6
.Quig_Dialog_2:      dw Quig_Dialog_2_Data+4,6
.Quig_Dialog_3:      dw Quig_Dialog_3_Data+4,6
.Quig_Dialog_4:      dw AppIcnLrg
.App_Form_List
       dw  Form1_Begin,0,0,0,0,0,0,Form1
.ControWindowDataList
     dw Form1_ControlWindowData
     dw 0 ;**** There is No Toolbar
;***
;**** Z80 version of Form Form1 ***
;***
.Form1
.Form1_Addr:                    db 0,0
.Form1_Begin:                   
.Form1_Status:                  db 1
.Form1_Display:                 db 84
.Form1_SizeAdjust:              db 20
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 3
.Form1_Top:                     dw 6
.Form1_Width:                   dw 200
.Form1_Height:                  dw 130
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 191
.Form1_ContentHeight:           dw 130
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 1024
.Form1_MaxHeight:               dw 212
.Form1_IconAddr:                dw 0
.Form1_Text:                    dw Form1_Text_Data+4
.Form1_Status_Text:             dw Form1_Status_Text_Data+4
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw 0;Form1_ControlTool
.Form1_ToolBarHeight:           dw 0;
     db 0,0,0,0,0,0,0,0,0       ;Symbos Reserved
.Form1_SuperWindow:             db  2
     ds 140,0                   ;Symbos Reserved
.Form1_Menu_List:               
.Form1_Menu:                    

        dw  0

;****
;**** Data Control Record (ControlWindow) ****
;****
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 6
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
;****
.Form1_ControlWindowData:       
;**** Object Window Background Data Record ****
dw 0,255*256+0,2,  0,0,1000,1000,0
;**** Object (Button1) Data Record ****
.Button1_Display      Equ 1
.Button1
.Button1_ID:                    dw 1
.Button1_Type:                  db 16   ;*Button
.Button1_ExtDataBank:           db 255
.Button1_Text:                  dw Button1_Text_Data+4
.Button1_Left:                  dw 15
.Button1_Top:                   dw 10
.Button1_Width:                 dw 74
.Button1_Height:                dw 11
.Button1_Code:                  dw QFunc_Button1_Event
;**** Object (Button2) Data Record ****
.Button2_Display      Equ 2
.Button2
.Button2_ID:                    dw 2
.Button2_Type:                  db 16   ;*Button
.Button2_ExtDataBank:           db 255
.Button2_Text:                  dw Button2_Text_Data+4
.Button2_Left:                  dw 109
.Button2_Top:                   dw 10
.Button2_Width:                 dw 74
.Button2_Height:                dw 11
.Button2_Code:                  dw QFunc_Button2_Event
;**** Object (TextBox1) Data Record ****
.TextBox1_Display      Equ 3
.TextBox1
.TextBox1_ID:                   dw 3
.TextBox1_Type:                 db 33   ;*TextBox
.TextBox1_ExtDataBank:          db 255
.TextBox1_ExtDataAddr:          dw TextBox1_ExtData
.TextBox1_Left:                 dw 11
.TextBox1_Top:                  dw 26
.TextBox1_Width:                dw 86
.TextBox1_Height:               dw 85
.TextBox1_Code:                 dw 0
;**** Object (TextBox2) Data Record ****
.TextBox2_Display      Equ 4
.TextBox2
.TextBox2_ID:                   dw 4
.TextBox2_Type:                 db 33   ;*TextBox
.TextBox2_ExtDataBank:          db 255
.TextBox2_ExtDataAddr:          dw TextBox2_ExtData
.TextBox2_Left:                 dw 104
.TextBox2_Top:                  dw 26
.TextBox2_Width:                dw 86
.TextBox2_Height:               dw 85
.TextBox2_Code:                 dw 0
;**** Object (Label1) Data Record ****
.Label1_Display      Equ 5
.Label1
.Label1_ID:                     dw 5
.Label1_Type:                   db 1   ;*Label
.Label1_ExtDataBank:            db 255
.Label1_ExtDataAddr:            dw Label1_ExtData
.Label1_Left:                   dw 16
.Label1_Top:                    dw 117
.Label1_Width:                  dw 176
.Label1_Height:                 dw 8
.Label1_Code:                   dw 0
;**** Object (TextBox1) Extra Data Record ****
.TextBox1_ExtData:              
.TextBox1_Text:                 dw  TextBox1_Text_Data+4 ;0
.TextBox1_Empty1:               dw  0 ;2
.TextBox1_CurrPos:              dw  0 ;4
.TextBox1_Selected:             dw  0 ;6
.TextBox1_InputLen:             dw  7 ;8
.TextBox1_InputMax:             dw  1024 ;10
.TextBox1_ReadOnly:             db  0 ;12
.TextBox1_TextPalette:          db  0 ;13
.TextBox1_Empty2:               db  0 ;14
.TextBox1_Font:                 dw  0 ;15
.TextBox1_Empty3:               db  0 ;17
.TextBox1_Lines:                dw  1 ;18
.TextBox1_Pixel:                dw  -1 ;20
.TextBox1_LinesMax:             dw  32 ;22
.TextBox1_Empty4:               dw  -8 ;24
.TextBox1_Empty5:               dw  0 ;26
.TextBox1_Empty6:               dw  TextBox1_ExtData ;28
.TextBox1_Empty7:               dw  0 ;30
.TextBox1_Empty8:               dw  0 ;32
.TextBox1_Empty9:               dw  0 ;34
.TextBox1_Empty10:              dw  0 ;36
.TextBox1_WordWrap:             db  2 ;38
.TextBox1_TabStop:              db  0 ;39
.TextBox1_Empty11:              db  0,0,0,0 ;40
.TextBox1_Empty12:              db  0,0,0,0 ;44
.TextBox1_Line1:                dw  0 ;48
.TextBox1_Line2:                dw  0 ;50
.TextBox1_Line3:                dw  0 ;52
.TextBox1_Line4:                dw  0 ;54
.TextBox1_Line5:                dw  0 ;56
.TextBox1_Line6:                dw  0 ;58
.TextBox1_Line7:                dw  0 ;60
.TextBox1_Line8:                dw  0 ;62
.TextBox1_Line9:                dw  0 ;64
.TextBox1_Line10:               dw  0 ;66
.TextBox1_Line11:               dw  0 ;68
.TextBox1_Line12:               dw  0 ;70
.TextBox1_Line13:               dw  0 ;72
.TextBox1_Line14:               dw  0 ;74
.TextBox1_Line15:               dw  0 ;76
.TextBox1_Line16:               dw  0 ;78
.TextBox1_Line17:               dw  0 ;80
.TextBox1_Line18:               dw  0 ;82
.TextBox1_Line19:               dw  0 ;84
.TextBox1_Line20:               dw  0 ;86
.TextBox1_Line21:               dw  0 ;88
.TextBox1_Line22:               dw  0 ;90
.TextBox1_Line23:               dw  0 ;92
.TextBox1_Line24:               dw  0 ;94
.TextBox1_Line25:               dw  0 ;96
.TextBox1_Line26:               dw  0 ;98
.TextBox1_Line27:               dw  0 ;100
.TextBox1_Line28:               dw  0 ;102
.TextBox1_Line29:               dw  0 ;104
.TextBox1_Line30:               dw  0 ;106
.TextBox1_Line31:               dw  0 ;108
.TextBox1_Line32:               dw  0 ;110
.TextBox1_Text_Data:            dw  TextBox1_Text:dw 1024
.TextBox1_Input:                db  "Welcome",0
    ds  1017
;**** Object (TextBox2) Extra Data Record ****
.TextBox2_ExtData:              
.TextBox2_Text:                 dw  TextBox2_Text_Data+4 ;0
.TextBox2_Empty1:               dw  0 ;2
.TextBox2_CurrPos:              dw  0 ;4
.TextBox2_Selected:             dw  0 ;6
.TextBox2_InputLen:             dw  7 ;8
.TextBox2_InputMax:             dw  1024 ;10
.TextBox2_ReadOnly:             db  0 ;12
.TextBox2_TextPalette:          db  0 ;13
.TextBox2_Empty2:               db  0 ;14
.TextBox2_Font:                 dw  0 ;15
.TextBox2_Empty3:               db  0 ;17
.TextBox2_Lines:                dw  1 ;18
.TextBox2_Pixel:                dw  -1 ;20
.TextBox2_LinesMax:             dw  32 ;22
.TextBox2_Empty4:               dw  -8 ;24
.TextBox2_Empty5:               dw  0 ;26
.TextBox2_Empty6:               dw  TextBox2_ExtData ;28
.TextBox2_Empty7:               dw  0 ;30
.TextBox2_Empty8:               dw  0 ;32
.TextBox2_Empty9:               dw  0 ;34
.TextBox2_Empty10:              dw  0 ;36
.TextBox2_WordWrap:             db  2 ;38
.TextBox2_TabStop:              db  0 ;39
.TextBox2_Empty11:              db  0,0,0,0 ;40
.TextBox2_Empty12:              db  0,0,0,0 ;44
.TextBox2_Line1:                dw  0 ;48
.TextBox2_Line2:                dw  0 ;50
.TextBox2_Line3:                dw  0 ;52
.TextBox2_Line4:                dw  0 ;54
.TextBox2_Line5:                dw  0 ;56
.TextBox2_Line6:                dw  0 ;58
.TextBox2_Line7:                dw  0 ;60
.TextBox2_Line8:                dw  0 ;62
.TextBox2_Line9:                dw  0 ;64
.TextBox2_Line10:               dw  0 ;66
.TextBox2_Line11:               dw  0 ;68
.TextBox2_Line12:               dw  0 ;70
.TextBox2_Line13:               dw  0 ;72
.TextBox2_Line14:               dw  0 ;74
.TextBox2_Line15:               dw  0 ;76
.TextBox2_Line16:               dw  0 ;78
.TextBox2_Line17:               dw  0 ;80
.TextBox2_Line18:               dw  0 ;82
.TextBox2_Line19:               dw  0 ;84
.TextBox2_Line20:               dw  0 ;86
.TextBox2_Line21:               dw  0 ;88
.TextBox2_Line22:               dw  0 ;90
.TextBox2_Line23:               dw  0 ;92
.TextBox2_Line24:               dw  0 ;94
.TextBox2_Line25:               dw  0 ;96
.TextBox2_Line26:               dw  0 ;98
.TextBox2_Line27:               dw  0 ;100
.TextBox2_Line28:               dw  0 ;102
.TextBox2_Line29:               dw  0 ;104
.TextBox2_Line30:               dw  0 ;106
.TextBox2_Line31:               dw  0 ;108
.TextBox2_Line32:               dw  0 ;110
.TextBox2_Text_Data:            dw  TextBox2_Text:dw 1024
.TextBox2_Input:                db  "Text...",0
    ds  1017
;**** Object (Label1) Extra Data Record ****
.Label1_ExtData:                
.Label1_Text:                   dw  Label1_Text_Data+4
.Label1_TextAppearance:         db  18
.Label1_TextAlignment:          db  194
.SyStud_TimerRoutines    dw 0
.Quig_File_Select_Ext          ds 4
.Quig_File_Select_File         ds 256
.AppTrnEnd


